/*!
 * Inheritance.js (0.4.12)
 *
 * Copyright (c) 2016 Brandon Sara (http://bsara.github.io)
 * Licensed under the CPOL-1.02 (https://github.com/bsara/inheritance.js/blob/master/LICENSE.md)
 */
!function(e,t){"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?module.exports=t():(e.I=t(),e.ObjectDefinition=e.I.ObjectDefinition,delete e.I.ObjectDefinition)}(this,function(){function inheritance(parent,objDefProps){parent=parent||Object,objDefProps=objDefProps||{};var objDef,objCtor=objDefProps.ctor||function(){return objDef.__super__.constructor.apply(this,arguments)},objDefName=objDefProps.__defName;return objDefName="string"==typeof objDefName&&objDefName.trim()?objDefName.trim():objCtor.name?objCtor.name:void 0,delete objDefProps.__defName,eval("objDef = function"+(objDefName?" "+objDefName:"")+"() { return objCtor.apply(this, arguments); };"),objDef.prototype=Object.create(parent.prototype),makeInheritable(objDef),_setupMixins(objDefProps),_setupStaticProperties(objDef,objDefProps),_setupPrivateProperties(objDef,objDefProps),_setupSuperFunction(objDef),_setupPublicProperties(objDef,objDefProps),_addOwnerIfFunction(objDef.prototype,objCtor),Object.defineProperty(objDef,"isObjDef",{get:function(){return!0}}),Object.defineProperty(objDef,"__super__",{get:function(){return parent.prototype}}),Object.defineProperty(objDef.prototype,"__ctor__",{get:function(){return objCtor}}),objDef}function _setupMixins(e){var t=e.mixins;null!=t&&t instanceof Array&&mixDeep(e,t)}function _setupStaticProperties(e,t){var r,o=t["static"];if(null!=o){for(r in o)_isReservedStaticProperty(r)||_addProperty(e,o,r);var n=o.consts;if(null!=n)for(r in n)if(!_isReservedStaticProperty(r)){var i=function(t,r){Object.defineProperty(e,t,{get:function(){return r}})};i(r,n[r])}}}function _setupPrivateProperties(e,t){var r,o=t["private"];if(null!=o){for(r in o)_isReservedInstanceProperty(r)||_addProperty(e.prototype,o,r,!0);var n=o["static"];if(null!=n)for(r in n)_isReservedStaticProperty(r)||_addProperty(e,n,r,!0)}}function _setupPublicProperties(e,t){e.prototype.constructor=_addOwnerIfFunction(e.prototype,e);for(var r in t)_isReservedInstanceProperty(r)||"mixins"===r||"private"===r||_updatePrototypeWithMixDeep(e.prototype,t,r)}function _setupSuperFunction(e){Object.defineProperty(e.prototype,"_super",{configurable:!1,enumerable:!1,writable:!1,value:function(){var e=arguments.callee.caller;if(e){var t=e.owner,r=t.constructor.__super__;if(r){if(e===t.constructor||e===t.__ctor__)return r.constructor.apply(this,arguments);var o=e.name;if(!o)for(var n=Object.getOwnPropertyNames(t),i=0;i<n.length;i++){var a=n[i],p=Object.getOwnPropertyDescriptor(t,a);if(p.value===e||p.get===e||p.set===e){o=a;break}}if(o){var f="get ",u="set ";o.startsWith(f)?o=o.replace(f,""):o.startsWith(u)&&(o=o.replace(u,""));var s,c=InternalUtils.getPropertyDescriptor(r,o),l=InternalUtils.getPropertyDescriptor(t,o);if(null!=c&&(s=null!=l.get&&l.get===e?c.get:null!=l.set&&l.set===e?c.set:c.value),"function"==typeof s&&null!=s)return s.apply(this,arguments)}}}}})}function _isReservedStaticProperty(e){return"consts"===e||"__super__"===e}function _isReservedInstanceProperty(e){return"constructor"===e||"ctor"===e||"static"===e||"_super"===e||"__ctor__"===e}function _isPropGetterOrSetter(e,t){var r=Object.getOwnPropertyDescriptor(e,t);return"undefined"!=typeof r&&("undefined"!=typeof r.get||"undefined"!=typeof r.set)}function _updatePrototypeWithMixDeep(e,t,r){if(!_isPropGetterOrSetter(t,r)&&!_isPropGetterOrSetter(e,r)){var o=e[r],n=t[r];if(null!=n&&"object"==typeof n&&"Object"===n.constructor.name&&null!=o&&"Object"===o.constructor.name)return void mixDeep(o,n)}_addProperty(e,t,r)}function _addProperty(e,t,r,o){o=o===!0;var n={},i=Object.getOwnPropertyDescriptor(t,r);if("undefined"!=typeof i)for(var a in i)n[a]=i[a];"undefined"!=typeof n.value&&_addOwnerIfFunction(e,n.value),"undefined"!=typeof n.get&&_addOwnerIfFunction(e,n.get),"undefined"!=typeof n.set&&_addOwnerIfFunction(e,n.set),o&&(n.enumerable=!1),Object.defineProperty(e,r,n)}function _addOwnerIfFunction(e,t){return"function"==typeof t&&(t.owner=e),t}function makeInheritable(e,t,r){if(null==e)throw new TypeError("`obj` cannot be undefined or null!");if(t!==!0&&null!=e.extend){if(r===!0)return e;throw new TypeError("`obj.extend` already exists! You're seeing this error to prevent the current extend function from being overwritten. See docs for how to override this functionality.")}return Object.defineProperty(e,"extend",{value:function(t){return inheritance(e,t)},configurable:!0,enumerable:!1,writable:!0}),e}function seal(e,t,r){if(null==e)throw new TypeError("`obj` cannot be undefined or null!");if(t!==!0&&null!=e.extend){if(r===!0)return e;throw new TypeError("`obj.extend` already exists! You're seeing this error to prevent the current extend function from being overwritten. See docs for how to override this functionality.")}return null!=e.extend&&delete e.extend,Object.defineProperties(e,{sealed:{get:function(){return!0}},extend:{configurable:!1,enumerable:!1,writable:!1,value:function(){throw new TypeError("The object definition you are trying to extend is sealed and cannot be inherited.")}}}),e}function mixDeep(e,t){var r=e||{};t instanceof Array||(t=[t]);for(var o=0;o<t.length;o++){var n=t[o];if(n)for(var i in n)n.hasOwnProperty(i)&&(null===n[i]||"object"!=typeof n[i]?r[i]=n[i]:mixDeep(r[i],n[i]))}return r}function mixPrototypeDeep(e,t){if(e=e||{prototype:{}},null==e.prototype)throw new TypeError("`obj.prototype` cannot be `undefined` or `null`!");return e.prototype=mixDeep(e.prototype,t),e}function mixPrototype(e,t){if(e=e||{prototype:{}},null==e.prototype)throw new TypeError("`obj.prototype` cannot be `undefined` or `null`!");return e.prototype=mix(e.prototype,t),e}function mix(e,t){var r=e||{};t instanceof Array||(t=[t]);for(var o=0;o<t.length;o++){var n=t[o];if(n)for(var i in n)n.hasOwnProperty(i)&&(r[i]=n[i])}return r}Object.defineProperty(Object.prototype,"mix",{value:function(){return mix(this,Array.prototype.slice.call(arguments))},configurable:!0,enumerable:!1,writable:!0}),Object.defineProperty(Object.prototype,"mixDeep",{value:function(){return mixDeep(this,Array.prototype.slice.call(arguments))},configurable:!0,enumerable:!1,writable:!0});var objDefsToExtend=[this.Object,this.ArrayBuffer,this.Array,this.DataView,this.Date,this.Error,this.EvalError,this.Float32Array,this.Float64Array,this.Function,this.Int8Array,this.Int16Array,this.Int32Array,this.Map,this.Number,this.Promise,this.Proxy,this.RangeError,this.ReferenceError,this.Reflect,this.RegExp,this.Set,this.String,this.Symbol,this.SyntaxError,this.TypeError,this.Uint8Array,this.Uint8ClampedArray,this.Uint16Array,this.Uint32Array,this.URIError,this.WeakMap,this.WeakSet];null!=this.Intl&&(objDefsToExtend.push(this.Intl.Collator),objDefsToExtend.push(this.Intl.DataTimeFormat),objDefsToExtend.push(this.Intl.NumberFormat));for(var i=0;i<objDefsToExtend.length;i++){var objDef=objDefsToExtend[i];null!=objDef&&makeInheritable(objDef,!0)}var InternalUtils={getPropertyDescriptor:function(e,t){var r=Object.getOwnPropertyDescriptor(e,t);if(null!=r)return r;if(null!=e.constructor&&null!=e.constructor.__super__)return InternalUtils.getPropertyDescriptor(e.constructor.__super__,t)}},ObjectDefinition={create:function(e){return inheritance(Object,e)},createSealed:function(e){return seal(inheritance(Object,e),!0)}};return seal(ObjectDefinition,!0),{mix:mix,mixDeep:mixDeep,mixPrototype:mixPrototype,mixPrototypeDeep:mixPrototypeDeep,inheritance:inheritance,makeInheritable:makeInheritable,seal:seal,ObjectDefinition:ObjectDefinition}});