/*!
 * Inheritance.js (0.4.12)
 *
 * Copyright (c) 2016 Brandon Sara (http://bsara.github.io)
 * Licensed under the CPOL-1.02 (https://github.com/bsara/inheritance.js/blob/master/LICENSE.md)
 */
!function(e,t){"function"==typeof define&&define.amd?define([],t):"object"==typeof exports?module.exports=t():(e.I=t(),e.ObjectDefinition=e.I.ObjectDefinition,delete e.I.ObjectDefinition)}(this,function(){function mix(e,t){var r=e||{};t instanceof Array||(t=[t]);for(var n=0;n<t.length;n++){var o=t[n];if(o)for(var i in o)o.hasOwnProperty(i)&&(r[i]=o[i])}return r}function mixDeep(e,t){var r=e||{};t instanceof Array||(t=[t]);for(var n=0;n<t.length;n++){var o=t[n];if(o)for(var i in o)o.hasOwnProperty(i)&&(null===o[i]||"object"!=typeof o[i]?r[i]=o[i]:mixDeep(r[i],o[i]))}return r}function mixPrototype(e,t){if(e=e||{prototype:{}},null==e.prototype)throw new TypeError("`obj.prototype` cannot be `undefined` or `null`!");return e.prototype=mix(e.prototype,t),e}function mixPrototypeDeep(e,t){if(e=e||{prototype:{}},null==e.prototype)throw new TypeError("`obj.prototype` cannot be `undefined` or `null`!");return e.prototype=mixDeep(e.prototype,t),e}function inheritance(parent,objDefProps){parent=parent||Object,objDefProps=objDefProps||{};var objDef,objCtor=objDefProps.ctor||function(){return objDef.__super__.constructor.apply(this,arguments)},objDefName=objDefProps.__defName;return objDefName="string"==typeof objDefName&&objDefName.trim()?objDefName.trim():objCtor.name?objCtor.name:void 0,delete objDefProps.__defName,eval("objDef = function"+(objDefName?" "+objDefName:"")+"() { return objCtor.apply(this, arguments); };"),objDef.prototype=Object.create(parent.prototype),makeInheritable(objDef),_setupMixins(objDefProps),_setupStaticProperties(objDef,objDefProps),_setupPrivateProperties(objDef,objDefProps),_setupSuperFunction(objDef),_setupPublicProperties(objDef,objDefProps),_addOwnerIfFunction(objDef.prototype,objCtor),Object.defineProperty(objDef,"isObjDef",{get:function(){return!0}}),Object.defineProperty(objDef,"__super__",{get:function(){return parent.prototype}}),Object.defineProperty(objDef.prototype,"__ctor__",{get:function(){return objCtor}}),objDef}function _setupMixins(e){var t=e.mixins;null!=t&&t instanceof Array&&mixDeep(e,t)}function _setupStaticProperties(e,t){var r,n=t["static"];if(null!=n){for(r in n)_isReservedStaticProperty(r)||_addProperty(e,n,r);var o=n.consts;if(null!=o)for(r in o)if(!_isReservedStaticProperty(r)){var i=function(t,r){Object.defineProperty(e,t,{get:function(){return r}})};i(r,o[r])}}}function _setupPrivateProperties(e,t){var r,n=t["private"];if(null!=n){for(r in n)_isReservedInstanceProperty(r)||_addProperty(e.prototype,n,r,!0);var o=n["static"];if(null!=o)for(r in o)_isReservedStaticProperty(r)||_addProperty(e,o,r,!0)}}function _setupPublicProperties(e,t){e.prototype.constructor=_addOwnerIfFunction(e.prototype,e);for(var r in t)_isReservedInstanceProperty(r)||"mixins"===r||"private"===r||_updatePrototypeWithMixDeep(e.prototype,t,r)}function _setupSuperFunction(e){Object.defineProperty(e.prototype,"_super",{configurable:!1,enumerable:!1,writable:!1,value:function(){var e=arguments.callee.caller;if(e){var t=e.owner,r=t.constructor.__super__;if(r){if(e===t.constructor||e===t.__ctor__)return r.constructor.apply(this,arguments);var n=e.name;if(!n)for(var o=Object.getOwnPropertyNames(t),i=0;i<o.length;i++){var p=o[i],f=Object.getOwnPropertyDescriptor(t,p);if(f.value===e||f.get===e||f.set===e){n=p;break}}if(n){var u="get ",a="set ";n.startsWith(u)?n=n.replace(u,""):n.startsWith(a)&&(n=n.replace(a,""));var c,s=InternalUtils.getPropertyDescriptor(r,n),l=InternalUtils.getPropertyDescriptor(t,n);if(null!=s&&(c=null!=l.get&&l.get===e?s.get:null!=l.set&&l.set===e?s.set:s.value),"function"==typeof c&&null!=c)return c.apply(this,arguments)}}}}})}function _isReservedStaticProperty(e){return"consts"===e||"__super__"===e}function _isReservedInstanceProperty(e){return"constructor"===e||"ctor"===e||"static"===e||"_super"===e||"__ctor__"===e}function _isPropGetterOrSetter(e,t){var r=Object.getOwnPropertyDescriptor(e,t);return"undefined"!=typeof r&&("undefined"!=typeof r.get||"undefined"!=typeof r.set)}function _updatePrototypeWithMixDeep(e,t,r){if(!_isPropGetterOrSetter(t,r)&&!_isPropGetterOrSetter(e,r)){var n=e[r],o=t[r];if(null!=o&&"object"==typeof o&&"Object"===o.constructor.name&&null!=n&&"Object"===n.constructor.name)return void mixDeep(n,o)}_addProperty(e,t,r)}function _addProperty(e,t,r,n){n=n===!0;var o={},i=Object.getOwnPropertyDescriptor(t,r);if("undefined"!=typeof i)for(var p in i)o[p]=i[p];"undefined"!=typeof o.value&&_addOwnerIfFunction(e,o.value),"undefined"!=typeof o.get&&_addOwnerIfFunction(e,o.get),"undefined"!=typeof o.set&&_addOwnerIfFunction(e,o.set),n&&(o.enumerable=!1),Object.defineProperty(e,r,o)}function _addOwnerIfFunction(e,t){return"function"==typeof t&&(t.owner=e),t}function makeInheritable(e,t,r){if(null==e)throw new TypeError("`obj` cannot be undefined or null!");if(t!==!0&&null!=e.extend){if(r===!0)return e;throw new TypeError("`obj.extend` already exists! You're seeing this error to prevent the current extend function from being overwritten. See docs for how to override this functionality.")}return Object.defineProperty(e,"extend",{value:function(t){return inheritance(e,t)},configurable:!0,enumerable:!1,writable:!0}),e}function seal(e,t,r){if(null==e)throw new TypeError("`obj` cannot be undefined or null!");if(t!==!0&&null!=e.extend){if(r===!0)return e;throw new TypeError("`obj.extend` already exists! You're seeing this error to prevent the current extend function from being overwritten. See docs for how to override this functionality.")}return null!=e.extend&&delete e.extend,Object.defineProperties(e,{sealed:{get:function(){return!0}},extend:{configurable:!1,enumerable:!1,writable:!1,value:function(){throw new TypeError("The object definition you are trying to extend is sealed and cannot be inherited.")}}}),e}var InternalUtils={getPropertyDescriptor:function(e,t){var r=Object.getOwnPropertyDescriptor(e,t);if(null!=r)return r;if(null!=e.constructor&&null!=e.constructor.__super__)return InternalUtils.getPropertyDescriptor(e.constructor.__super__,t)}},ObjectDefinition={create:function(e){return inheritance(Object,e)},createSealed:function(e){return seal(inheritance(Object,e),!0)}};return seal(ObjectDefinition,!0),{mix:mix,mixDeep:mixDeep,mixPrototype:mixPrototype,mixPrototypeDeep:mixPrototypeDeep,inheritance:inheritance,makeInheritable:makeInheritable,seal:seal,ObjectDefinition:ObjectDefinition}});